function init()
	print("Hello from LUA! This is the real one.\n")
	testScene("marble")
	-- testScene("materials")
	--save("hello")
	load("assets/logo.airpaint", 2)
end

function renderEye()
  -- This gets called for every eye. If we want to draw from LUA we can do it here.
end

-- Globals that are read out by the C++ code.
floorsize = 2.0
FAST = 12
SLOW = 2

-- activeTab = "Sculpt"
tabs = { "Sculpt", "World" }
activeTab = tabs[1]
tool = "Add"
toolShape = "Sphere"
currentSlot = "1"
loadSpeed = FAST

mirror = false
drawSize = 0.08
material_r = 1.0
material_g = 0.02
material_b = 0.02
material_h = 1.0
material_s = 1.0
material_v = 1.0
material_metalness = 0.0
material_roughness = 0.2

colorslots_r = {0, 0, 0, 0, 0, 0}
colorslots_g = {0, 0, 0, 0, 0, 0}
colorslots_b = {0, 0, 0, 0, 0, 0}
colorslots_metalness = {0, 0, 0, 0, 0, 0}
colorslots_roughness = {0, 0, 0, 0, 0, 0}

-- UI layout
padding_x = 1.5
padding_y = 3
light_env = 1
text_scale = 0.9
h = 9

function drawStart()
	-- Save the current color in the next colorslot.

end

function processUI()
	local xstart = -20
	local ystart = -30
	local x = xstart - padding_x
	local y = ystart - padding_y
	local width = 55.0
	local right = width + xstart
	beginPanel(x, y, 55.0, 62.0)
	local tabWidth = 16
	setTextScale(text_scale)

	for n,name in pairs(tabs) do
		if textButton(name, x, y, tabWidth, h/2, activeTab == name) then
			activeTab = name
		end
		x = x + tabWidth + padding_x
	end

	x = xstart
	y = y + h / 2 + padding_x

	if activeTab == "Sculpt" then
		if button("Draw", "plus", x, y, h, h, tool == "Add") then
			tool = "Add"
		end
		x = x + h + padding_x
		if button("Erase", "minus", x, y, h, h, tool == "Subtract") then
			tool = "Subtract"
		end
		x = x + h + padding_x
		if button("Paint", "paint", x, y, h, h, tool == "Paint") then
			tool = "Paint"
		end
		x = x + h + padding_x
		if button("Pick Color", "dropper", x, y, h, h, tool == "Dropper") then
			tool = "Dropper"
		end
		x = x + h + padding_x
		x = xstart

		y = y + h + padding_y

		if button("Sphere", "sphere", x, y, h, h, toolShape == "Sphere") then
			toolShape = "Sphere"
		end
		x = x + h + padding_x
		if button("Box", "box", x, y, h, h, toolShape == "Box") then
			toolShape = "Box"
		end
		x = x + h + padding_x
		if button("Cylinder", "cylinder", x, y, h, h, toolShape == "Cylinder") then
			toolShape = "Cylinder"
		end
		x = x + h + padding_x

		local slider_h = h
		drawSize = slider("Draw Size", x, y, right - x - padding_x*2, h, 0.02, 0.25, drawSize, 1.0)
		y = y + h + padding_y

		x = xstart
		colorPicker("material", x, y, 30, 30, 0xFFFFFF)

		x = x + padding_x + 30
		y = y + 30/2 - h - padding_y / 2
		material_roughness = slider("Roughness", x, y, right - x - padding_x*2, slider_h, 0.0, 1.0, material_roughness)
		y = y + slider_h + padding_y
		if textButton("Metallic", x, y, right - x - padding_x*2, slider_h, material_metalness == 1.0) then
			if material_metalness > 0.0 then
				material_metalness = 0.0
			else
				material_metalness = 1.0
			end
		end
		x = xstart
		y = y + slider_h + padding_y

	elseif activeTab == "Material" then
		local slider_h = h * 0.6
		local slider_w = 30
		material_r = slider("", "Red", x, y, slider_w, slider_h, 0.0, 1.0, material_r)
		x = x + slider_w + padding_x
		rect(x, y, slider_h * 2, slider_h * 3 + padding_y * 2,  material_r, material_g, material_b, 1.0)
		x = xstart
		y = y + slider_h + padding_y

		material_g = slider("", "Green", x, y, slider_w, slider_h, 0.0, 1.0, material_g)
		x = xstart
		y = y + slider_h + padding_y

		material_b = slider("", "Blue", x, y, slider_w, slider_h, 0.0, 1.0, material_b)
		x = xstart
		y = y + slider_h + padding_y

		material_roughness = slider("", "Roughness", x, y, slider_w, slider_h, 0.0, 1.0, material_roughness)
		x = x + slider_w + padding_x
		if button("Metallic", "empty", x, y, slider_h * 2, slider_h, material_metalness == 1.0) then
			if material_metalness > 0.0 then
				material_metalness = 0.0
			else
				material_metalness = 1.0
			end
		end
		y = y + slider_h + padding_y
	elseif activeTab == "World" then
		x = xstart
		if button("Day", "day", x, y, h, h, light_env == 1) then
			light_env = 1
		end
		x = x + h + padding_x
		if button("Night", "night", x, y, h, h, light_env == 0) then
			light_env = 0
		end
		y = y + h + padding_y
		x = xstart

		if button("Clear", "new", x, y, h, h, false) then
			clear()
		end
		x = x + h + padding_x
		if button("SphereTest", "sphere", x, y, h, h, false) then
			testScene("materials")
		end
		x = x + h + padding_x
		if button("Marble Block", "box", x, y, h, h, false) then
			testScene("marble")
		end
		y = y + h + padding_y

		x = xstart
		if button("Load", "load", x, y, h, h, false) then
			load(currentSlot .. ".airpaint", loadSpeed)
		end
		x = x + h + padding_x
		if button("Save", "save", x, y, h, h, false) then
			save(currentSlot .. ".airpaint")
		end
		x = x + h + padding_x
		y = y + (h - (h/2)) / 2
		for i = 1,4 do
			if textButton(tostring(i), x, y, h/2, h/2, currentSlot == tostring(i)) then
				currentSlot = tostring(i)
			end
			x = x + h/2 + padding_x
		end

		--
		--y = y + h + padding_y + padding_y
		--x = xstart
		--if textButton("Fast Load", x, y, h, h, loadSpeed == FAST) then
		--	loadSpeed = FAST
		--end
		--x = x + h + padding_x
		--if textButton("Slow Load", x, y, h, h, loadSpeed == SLOW) then
		--	loadSpeed = SLOW
		--end

		y = y + h + padding_y + padding_y

		x = xstart
		label("AirPaint VR by Henrik Rydgard", x, y)
		y = y + h/2
		label("Copyright 2017 Millionth Line AB", x, y)
		y = y + h/2
		label("www.airpaintvr.com", x, y)
		y = y + h/2
	end
	drawPointer()
end
